//+------------------------------------------------------------------+
//|                                     Average cumulative trend.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, CF."

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Green
#property indicator_color3 Red

// Parameters for chose indicator
extern string indicator = "Ergodic_CCI";
extern int pq =4;          
extern int pr = 8;         
extern int ps = 5;         
extern int trigger =4;     
extern int period_income_days = 60; // period in days for average bar pips income (1 month is 20 days)

double Buffer1[];
double Buffer2[];
double Buffer3[];

int prev_signal = 0;

int init()
{
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   IndicatorShortName("Average cumulative trend");
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0, pr);
   SetIndexBuffer(0,Buffer1);

   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1, pr);
   SetIndexBuffer(1,Buffer2);

   SetIndexStyle(2,DRAW_LINE);
   SetIndexDrawBegin(2, pr);
   SetIndexBuffer(2,Buffer3);
   
   return(0);
}

int start()
{
   int i;
   
   int period_income = period_income_days * 1440 / Period();
   
   if( ( Bars < pr + 1) || ( Bars < period_income))
      return(0);
    
   double cum = 0.0;
   double Spread = Ask - Bid;

   for(i = period_income; i >= 0; i--)
   {
      double signal = iCustom( NULL, 0, indicator, pq, pr, ps, trigger, 0, i); 

      if ( prev_signal != signal)
      {
         if ( Buffer2[i+1] != EMPTY_VALUE)
            Buffer1[i+1] = Buffer2[i+1];
         else if ( Buffer3[i+1] != EMPTY_VALUE)
            Buffer1[i+1] = Buffer3[i+1];

         Buffer1[i] = Buffer1[i+1];
         Buffer2[i] = EMPTY_VALUE;
         Buffer3[i] = EMPTY_VALUE;
      }
      else
      {
         Buffer1[i] = EMPTY_VALUE;
      
         if ( signal >= 0)
         {
            cum = cum + (Close[i] - Open[i] - Spread) / Point;
            Buffer2[i] = cum / period_income;
            Buffer3[i] = EMPTY_VALUE;
            if ( Buffer2[i+1] == EMPTY_VALUE )
               Buffer2[i+1] = Buffer1[i+1];
         }
         else
         {	   
            cum = cum + (Open[i] - Close[i] - Spread) / Point;
            Buffer3[i] = cum / period_income;
            Buffer2[i] = EMPTY_VALUE;
            if ( Buffer3[i+1] == EMPTY_VALUE )
               Buffer3[i+1] = Buffer1[i+1];
         }
      }

      prev_signal = signal;
   }
      
   return(0);
 }


